#FabAcess Step By Step

This document provides a step by step Instruction on how to get FabAcess running. At the end of this description you will have:
- 2 Users registered to your system
- 2 Shellies registered to you system
- 1 Shelly configured as a door-opener
- 1 Shelly configured to identify if a machine is just switched on or realy running
- 2 QR-Codes generate to acess a machine

##Step 1 Installing the BFFH-Server
there are multiple ways to install the BFFH server. This can bei either done via 
- docker - see docker installation document
- installing from source - see installing from source documentation
- installing on Ubuntu for dummies

##Get the FabAccess App
get the App via Apple Store or Google Apps.



`ip a`

17. Configure your Shelly
as long as your Shelly has not been given the credentials for a WLAN, it will create an access point (AP) for configuration. This AP will appear in your list of WLAN. 
Connect to this Shelly-AP and connect to `192.168.33.1` in your browser. A configuration page should appear.
If your Shelly is already connected to your WLAN, you must find the assigned IP-Adress (e.g. by looking into your router). Enter this IP Adress in your browser and you will get the configuration page.

18. MQTT Client setup
goto "Internet & Security" -> "Advanced - Developer Settings"
enable "MQTT"
enter the IP-Adress from Step 16 in the field "IP-Adress"
As we did not define MQTT credentials in mosquitto yet, no creadentials need to be filled in.
To find the "ID" of your Shelly activate "Use custom MQTT prefix" (but do not change it!). This should be somthing like:
`shelly1-123456789ABC` for a Shelly 1
`shelly1pm-123456` for a Shelly 1PM
note this ID for later
**- save**
**- re-check the settings!**

19. WLAN Client setup
goto "Internet & Security" -> "WIFI MODE - CLIENT"
Set WLAN Credentials

20. Configure Diflouroborane
Open the file "bffh.dhall" in the GUI Editor (just by double-clicking it)
Change `Shelly_123` to your Shelly name, e.g. `shelly1-123456789ABC`  (**case sensitive!, dash sensitive!**) in "Link up machines to actors" and in "actors".
Change the third IP-adress under "listens" to the IP-adress of your computer.
**- save**

21. start Diflouroburane
change to the directory in the console where you checked for the ip-address
`cd BFFH/bffh/target/release`
load settings to Diflouroborane:
`./diflouroborane -c examples/bffh.dhall --load examples`
start Diflouroborane:
`./diflouroborane -c examples/bffh.dhall`

**Important**
every time you change the bffh.dhal you need to reload the settings (otherwise the App will not connect to the server on restart): 
`./diflouroborane -c examples/bffh.dhall --load examples`
and restart start Diflouroborane:
`./diflouroborane -c examples/bffh.dhall`

Download the borepin APP as described previously
- start the App
- press: "Connect to new Server"
- press: Enter the IP of your computer in the "Host"-Field
- Enter your Username and Password.

To connect to the demo instance
- start the App
- press: "Connect to new Server"
- press: "Demo Host Address"
- User: "Testuser"
- Passw: "secret"
